/* Copyright (C) 2009 Papavasileiou Dimitris                             
 *                                                                      
 * This program is free software: you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation, either version 3 of the License, or    
 * (at your option) any later version.                                  
 *                                                                      
 * This program is distributed in the hope that it will be useful,      
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        
 * GNU General Public License for more details.                         
 *                                                                      
 * You should have received a copy of the GNU General Public License    
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _SOURCE_H_
#define _SOURCE_H_

#include <lua.h>
#include <AL/al.h>
#include "node.h"

@interface Source: Node {
    ALuint index;
    ALenum state;
    ALuint name, frequency;

    double tick;
    int size, finished;
}

-(ALint) index;
-(Source *) initWithSamples: (ALshort *) samples
                     ofSize: (int) n
		atFrequency: (int) f;
-(void) freeBuffers;
-(int) length;
-(int) frequency;

@end

#endif
